% RJMCMC warp matrix
function [Max_SF_pattern,detector_id]=find_gaps_type1(seq, Motif_B_log,indel_probability, indel_type, indel_level)
% Tong @ CUHK Oct 2011
% Inputs: 
% the sequence: seq
% Motif/background  Theta/theta_0
% indel probability 
% indel type 
% indel level(number) for recursive
Max_SF_pattern=[];
W=size(Motif_B_log,2);
max_indel_length=min(3,floor(W/2));
seq_length=numel(seq);
seq_indicator=ones(1,seq_length);


detector_id=0;
seq_address_in_pattern=ones(1,seq_length); %elements belongs to which col in matirx
for i=1:seq_length
    seq_address_in_pattern(i)=mod(i,W);
end
seq_address_in_pattern(seq_address_in_pattern==0)=W;
Max_SF=-10000;
Max_SF_pattern.SF=Max_SF;
if indel_type==1 %insertions
    for i=1:max_indel_length
        if indel_level==1
            if mod(seq_length-i,W)~=0
                continue
            else
                detector_id=1; %whether a indel detection is applied
            end
        end
        for j=1:seq_length-i+1
            %0 denote a insertions
            temp.indel_length=i;
            temp.indel_address=j;
            temp.indel_type=indel_type;
           temp.S_Ind=seq_indicator;
           temp.S_Ind(j:j+i-1)=0;
           if sum(temp.S_Ind)~=0 
              % temp.S_Ind
               temp.seq=seq(temp.S_Ind==1);%seqyence
              
               temp.seq_address_motif=seq_address_in_pattern(temp.S_Ind==1);

               temp.S_Ind(temp.S_Ind==0)=[];% deletion the insertions
               temp.seq_address_motif(j:end)=temp.seq_address_motif(j:end)-i;
               temp.seq_address_motif=mod(temp.seq_address_motif,W);
               temp.seq_address_motif(temp.seq_address_motif==0)=W;

               %calculate the difference for SF
               temp.SF=log(indel_probability);
               for k=1:numel(temp.seq_address_motif)
                   temp.SF=temp.SF+Motif_B_log(temp.seq(k),temp.seq_address_motif(k));
               end
           else
               temp.SF=log(indel_probability);
           end
           if temp.SF>Max_SF
               Max_SF_pattern=temp;
           end
           clear temp
        end
    end

else %deletion for 2
    for i=1:max_indel_length
        if indel_level==1
            if mod(seq_length+i,W)~=0
                continue
            else
                detector_id=1; %whether a indel detection is applied
            end
        end
        for j=1:seq_length+1
              %0 denote a insertions
            temp.indel_length=i;
            temp.indel_address=j;
            temp.indel_type=indel_type;
           temp.S_Ind=seq_indicator;
          % temp.S_Ind(j:j+i-1)=0;
           temp.seq=seq;%seqyence
           if j<=seq_length
               temp.seq_address_motif=seq_address_in_pattern(j:end)+i;
               temp.seq_address_motif=mod(temp.seq_address_motif,W);
               temp.seq_address_motif(temp.seq_address_motif==0)=W;
           else
                temp.seq_address_motif=seq_address_in_pattern;
           end
           %calculate the difference for SF
           temp.SF=log(indel_probability);
           for k=1:numel( temp.seq_address_motif)
               temp.SF=temp.SF+Motif_B_log(temp.seq(k),temp.seq_address_motif(k));
           end
           if temp.SF>Max_SF
               Max_SF_pattern=temp;
           end
           clear temp
            
        end
    end
end

if mod(seq_length,W)==0
       no_indel_SF=0;
       for k=1:seq_length
           no_indel_SF=no_indel_SF+Motif_B_log(seq(k),seq_address_in_pattern(k));
       end
       if no_indel_SF>Max_SF 
           Max_SF_pattern.SF=no_indel_SF;
            Max_SF_pattern.S_Ind=seq_indicator;
            Max_SF_pattern.indel_type=0;
            detector_id=1;
       end
end

%if indel_level-1~=0
%                [Max_SF,path]=find_gaps( indel_level-1)
%end

end





